<template>
  <div class="app-container">
    <div class="toolbar-container">
      <el-button class="toolbar-item" style="margin-left: 10px;" type="primary" icon="el-icon-edit" @click="handleCreate">
        添加
      </el-button>
    </div>

    <el-table
      v-loading="listLoading"
      :data="list"
      element-loading-text="Loading"
      border
      fit
      highlight-current-row
    >
      <el-table-column align="center" label="ID" width="95">
        <template slot-scope="scope">
          {{ scope.$index }}
        </template>
      </el-table-column>
      <el-table-column label="用户名" width="150" align="center">
        <template slot-scope="scope">
          {{ scope.row.name }}
        </template>
      </el-table-column>
      <el-table-column label="公钥" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.pubkey }}</span>
        </template>
      </el-table-column>
      <el-table-column label="备注" width="200" align="center">
        <template slot-scope="scope">
          {{ scope.row.remark }}
        </template>
      </el-table-column>
      <el-table-column fixed="right" label="操作" width="110" align="center">
        <template slot-scope="scope">
          <el-button @click="handleMod(scope.row)" type="text" size="small">修改</el-button>
          <el-button @click="delUser(scope.row)" type="text" size="small">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-dialog :title="dialogTitle" :visible.sync="dialogFormVisible">
      <el-form ref="dataForm" :rules="rules" :model="temp" label-position="left" label-width="70px" style="width: 400px; margin-left:50px;">
        <el-form-item label="用户名" prop="title">
          <el-input v-model="temp.username" />
        </el-form-item>
        <el-form-item label="密码" prop="password">
          <el-input v-model="temp.password" type="password"/>
        </el-form-item>
        <el-form-item label="公钥">
          <el-input v-model="temp.pubkey" rows="10" type="textarea" />
        </el-form-item>
        <el-form-item label="备注">
          <el-input v-model="temp.remark" :autosize="{ minRows: 2, maxRows: 4}" type="textarea" placeholder="Please input" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">
          取消
        </el-button>
        <el-button type="primary" @click="handleUserDialog()">
          确认
        </el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { get_users, add_user, del_user, update_user } from '@/api/usermanage'

export default {
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'gray',
        deleted: 'danger'
      }
      return statusMap[status]
    }
  },
  data() {
    return {
      list: null,
      listLoading: true,
      temp: {
        username: undefined,
        password: undefined,
        pubkey: undefined,
        remark: undefined
      },
      oritemp: null,
      dialogIsCreate: true,
      dialogFormVisible: false,
      dialogTitle: "创建用户",
      rules: {},
      createrules: {
        username: [{ required: true, message: '请输入用户名', trigger: 'change' }],
        password: [{ required: true, message: '请输入密码', trigger: 'change' }],
      },
      modifyrules: {
        username: [{ required: true, message: '请输入用户名', trigger: 'change' }],
      },
    }
  },
  created() {
    this.fetchData()
  },
  methods: {
    fetchData() {
      this.listLoading = true
      get_users().then(response => {
        this.list = response.content
        this.listLoading = false
      })
    },
    delUser(row) {
      console.log("Going to delete " + row.name)
      del_user(row.name).then(() => {
          this.$notify({
              title: '成功',
              message: '用户删除成功',
              type: 'success',
              duration: 2000
            })
            this.fetchData()
      })
    },
    handleCreate(){
      this.temp = {
        username: undefined,
        password: undefined,
        pubkey: null,
        remark: null
      }
      this.rules = this.createrules
      this.dialogTitle = '创建用户'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    handleMod(row){
      this.temp = {
        username: row.name,
        password: undefined,
        pubkey: row.pubkey,
        remark: undefined
      }
      this.oritemp = {}
      Object.assign(this.oritemp, this.temp)
      this.rules = this.modifyrules
      this.dialogIsCreate = false
      this.dialogTitle = '修改用户'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    handleUserDialog(){
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
           if (this.dialogIsCreate) {
              add_user(this.temp.username, this.temp.password, this.temp.pubkey).then(() => {
                this.dialogFormVisible = false
                this.$notify({
                  title: '成功',
                  message: '用户创建成功',
                  type: 'success',
                  duration: 2000
                })
                this.fetchData()
            })
           } else {
               var password = this.temp.password
               if (this.temp.password == "" || this.temp.password == undefined){
                   password = null
               }
               update_user(this.temp.username, password, this.temp.pubkey).then(() => {
                   this.dialogFormVisible = false
                   this.$notify({
                       title: '成功',
                       message: '用户修改成功',
                       type: 'success',
                       duration: 2000
                   })
                   this.fetchData()
               })
             }
        }
      })
    }
  }
}
</script>
